"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var STREAM_MODULE = '@weex-module/stream';

var eventTarget = require('event-target-shim');

var UNSENT = 0;
var OPENED = 1;
var HEADERS_RECEIVED = 2;
var LOADING = 3;
var DONE = 4;
var XHR_EVENTS = ['abort', 'error', 'load', 'loadstart', 'progress', 'timeout', 'loadend', 'readystatechange'];

module.exports = function (__weex_require__) {
  var XMLHttpRequest =
  /*#__PURE__*/
  function (_eventTarget) {
    _inherits(XMLHttpRequest, _eventTarget);

    // EventTarget automatically initializes these to `null`.
    function XMLHttpRequest() {
      var _this;

      _classCallCheck(this, XMLHttpRequest);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(XMLHttpRequest).call(this));

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "UNSENT", UNSENT);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "OPENED", OPENED);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "HEADERS_RECEIVED", HEADERS_RECEIVED);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "LOADING", LOADING);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "DONE", DONE);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onload", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onloadstart", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onprogress", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "ontimeout", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onerror", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onabort", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onloadend", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onreadystatechange", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "readyState", UNSENT);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "responseHeaders", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "status", 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "statusText", '');

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "timeout", 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_aborted", false);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_hasError", false);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_headers", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_lowerCaseResponseHeaders", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_method", null);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_response", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_responseType", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_response", '');

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_sent", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_url", null);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_timedOut", false);

      _this._reset();

      return _this;
    }

    _createClass(XMLHttpRequest, [{
      key: "_reset",
      value: function _reset() {
        this.readyState = this.UNSENT;
        this.responseHeaders = undefined;
        this.status = 0;
        this._hasError = false;
        this._headers = {};
        this._response = '';
        this._responseType = '';
        this._sent = false;
        this._lowerCaseResponseHeaders = {};
        this._timedOut = false;
      }
    }, {
      key: "getAllResponseHeaders",
      value: function getAllResponseHeaders() {
        if (!this.responseHeaders) {
          // according to the spec, return null if no response has been received
          return null;
        }

        var headers = this.responseHeaders || {};
        return Object.keys(headers).map(function (headerName) {
          return headerName + ': ' + headers[headerName];
        }).join('\r\n');
      }
    }, {
      key: "getResponseHeader",
      value: function getResponseHeader(header) {
        var value = this._lowerCaseResponseHeaders[header.toLowerCase()];

        return value !== undefined ? value : null;
      }
    }, {
      key: "setRequestHeader",
      value: function setRequestHeader(header, value) {
        if (this.readyState !== this.OPENED) {
          throw new Error('Request has not been opened');
        }

        this._headers[header.toLowerCase()] = String(value);
      }
    }, {
      key: "open",
      value: function open(method, url, async) {
        /* Other optional arguments are not supported yet */
        if (this.readyState !== this.UNSENT) {
          throw new Error('Cannot open, already sending');
        }

        if (async !== undefined && !async) {
          // async is default
          throw new Error('Synchronous http requests are not supported');
        }

        if (!url) {
          throw new Error('Cannot load an empty url');
        }

        this._method = method.toUpperCase();
        this._url = url;
        this._aborted = false;
        this.setReadyState(this.OPENED);
      }
    }, {
      key: "send",
      value: function send(data) {
        var _this2 = this;

        if (this.readyState !== this.OPENED) {
          throw new Error('Request has not been opened');
        }

        if (this._sent) {
          throw new Error('Request has already been sent');
        }

        this._sent = true;

        var nativeFetch = __weex_require__(STREAM_MODULE).fetch;

        nativeFetch({
          method: this._method,
          url: this._url,
          headers: this._headers,
          body: data,
          type: 'text'
        }, function (response) {
          try {
            typeof response === 'string' && (response = JSON.parse(response));
            _this2.status = response.status;
            _this2.statusText = response.statusText;

            _this2.setResponseHeaders(response.headers);

            if (response.ok) {
              _this2._response = response.data;
            } else {
              if (_this2._responseType === '' || _this2._responseType === 'text') {
                _this2._response = response.data;
              }

              _this2._hasError = true;
            }
          } catch (err) {}

          _this2.setReadyState(_this2.DONE);
        }, function (progress) {
          _this2.status = progress.status;
          _this2.statusText = progress.statusText;

          _this2.setResponseHeaders(progress.headers);

          _this2.setReadyState(progress.readyState);
        });
      }
    }, {
      key: "abort",
      value: function abort() {
        this._aborted = true; // TODO: Weex native not support abort now
        // only call onreadystatechange if there is something to abort,
        // below logic is per spec

        if (!(this.readyState === this.UNSENT || this.readyState === this.OPENED && !this._sent || this.readyState === this.DONE)) {
          this._reset();

          this.setReadyState(this.DONE);
        } // Reset again after, in case modified in handler


        this._reset();
      }
    }, {
      key: "setResponseHeaders",
      value: function setResponseHeaders(responseHeaders) {
        this.responseHeaders = responseHeaders || null;
        var headers = responseHeaders || {};
        this._lowerCaseResponseHeaders = Object.keys(headers).reduce(function (lcaseHeaders, headerName) {
          lcaseHeaders[headerName.toLowerCase()] = headers[headerName];
          return lcaseHeaders;
        }, {});
      }
    }, {
      key: "setReadyState",
      value: function setReadyState(newState) {
        this.readyState = newState;
        this.dispatchEvent({
          type: 'readystatechange'
        });

        if (newState === this.DONE) {
          if (this._aborted) {
            this.dispatchEvent({
              type: 'abort'
            });
          } else if (this._hasError) {
            if (this._timedOut) {
              this.dispatchEvent({
                type: 'timeout'
              });
            } else {
              this.dispatchEvent({
                type: 'error'
              });
            }
          } else {
            this.dispatchEvent({
              type: 'load'
            });
          }

          this.dispatchEvent({
            type: 'loadend'
          });
        }
      }
    }, {
      key: "responseType",
      get: function get() {
        return this._responseType;
      },
      set: function set(responseType) {
        if (this._sent) {
          throw new Error('Failed to set the \'responseType\' property on \'XMLHttpRequest\': The ' + 'response type cannot be set after the request has been sent.');
        }

        this._responseType = responseType;
      }
    }, {
      key: "responseText",
      get: function get() {
        if (this._responseType !== '' && this._responseType !== 'text') {
          throw new Error("The 'responseText' property is only available if 'responseType' " + "is set to '' or 'text', but it is '".concat(this._responseType, "'."));
        }

        if (this.readyState < LOADING) {
          return '';
        }

        return this._response;
      }
    }, {
      key: "response",
      get: function get() {
        var responseType = this.responseType;

        if (responseType === '' || responseType === 'text') {
          return this.readyState < LOADING || this._hasError ? '' : this._response;
        }

        if (this.readyState !== DONE) {
          return null;
        }
      }
    }]);

    return XMLHttpRequest;
  }(eventTarget.apply(void 0, XHR_EVENTS));

  _defineProperty(XMLHttpRequest, "UNSENT", UNSENT);

  _defineProperty(XMLHttpRequest, "OPENED", OPENED);

  _defineProperty(XMLHttpRequest, "HEADERS_RECEIVED", HEADERS_RECEIVED);

  _defineProperty(XMLHttpRequest, "LOADING", LOADING);

  _defineProperty(XMLHttpRequest, "DONE", DONE);

  return XMLHttpRequest;
};